<template src="./template.html"></template>

<script lang="ts">
import { clone, cloneDeep } from "lodash";
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { regexEmail } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({
  components: {},
})
export default class ManageSellersComponent extends Vue {
  @Prop()
  tab!: number;

  config = {
    page: 1,
    limit: 25,
    search: "",
    isActive: true,
  };
  page = 1;

  listStatus = [
    {
      title: "All",
      value: 0,
    },
    {
      title: "Active",
      value: 1,
    },
    {
      title: "Deactive",
      value: 2,
    },
  ];
  status = 0;

  dialogAddSeller = false;
  dialogViewDetail = false;
  loading = false;
  loadingTable = false;

  seller = {
    email: "",
    password: "",
    phoneNumber: "",
    name: "",
    supportEmail: "",
  };

  sellerDetail = {
    email: "",
    password: "",
    phoneNumber: "",
    name: "",
    supportEmail: "",
  };

  get listAdminSeller() {
    const listAdminSeller = cloneDeep(
      this.$store.state.adminUsers.listAdminSeller
    );
    return listAdminSeller || [];
  }

  get totalPage() {
    return this.$store.state.adminUsers.totalPage || 0;
  }

  mounted() {
    this.onGetListSeller();
  }

  async onGetListSeller() {
    try {
      this.loadingTable = true;
      const config = this.config;
      if (this.status === 1) {
        config["isActive"] = true;
      } else if (this.status === 2) {
        config["isActive"] = false;
      } else {
        //@ts-ignore
        delete this.config.isActive;
      }
      await this.$store.dispatch("adminUsers/onGetListAdminSeller", {
        ctx: this,
        query: this.config,
      });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogAddSeller() {
    this.dialogAddSeller = true;
    this.clearData();
  }

  closeDialogAddSeller() {
    this.dialogAddSeller = false;
  }

  async onAddSeller() {
    try {
      if (
        !(
          this.seller.email ||
          this.seller.name ||
          this.seller.password ||
          this.seller.phoneNumber ||
          this.seller.supportEmail
        )
      ) {
        return this.$pushNotification.error("Please enter full information");
      }

      if (
        !regexEmail.test(this.seller.email) ||
        !regexEmail.test(this.seller.supportEmail)
      ) {
        return this.$pushNotification.error("Email or support email invalid");
      }
      await this.$api.userAdmin.createSeller(this.seller);
      this.$pushNotification.success("Create a successful partner");
      this.clearData();
      this.dialogAddSeller = false;
      this.onGetListSeller();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  openDialogViewDetail(seller: any) {
    this.sellerDetail = seller;
    this.dialogViewDetail = true;
  }

  async onChangeStatus(seller: any) {
    try {
      if (seller.isActive) {
        await this.$api.userAdmin.activeUser(seller._id);
      } else {
        await this.$api.userAdmin.deactiveUser(seller._id);
      }
      this.$pushNotification.success("Change status successfully");
      this.onGetListSeller();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  clearData() {
    this.seller = {
      email: "",
      password: "",
      phoneNumber: "",
      name: "",
      supportEmail: "",
    };
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListSeller();
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListSeller();
  }

  @Watch("tab")
  changeTab(value: number) {
    if (value === 0) {
      this.onGetListSeller();
    }
  }
}
</script>

<style scoped lang="scss">
.form-resp {
  @media (max-width: 600px) {
    width: 100% !important;
  }
}
</style>
